#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <wchar.h>
#include <locale.h>

// UNICODE (UTF-8) символьные строки:
//----------------------------------------------------------
void test00( void ) {
   printf( "размер символа wchar_t вашей реализации = %d байт\n", (int)sizeof( wchar_t ) );
}
//----------------------------------------------------------
void test01( void ) {
   char str[] = "Привет по-русски!";
   printf( "%s [%d байт]\n", str, (int)strlen( str ) ); 
}
//----------------------------------------------------------
void test02( void ) {
   char str[] = "Hello, 世界";
   printf( "%s [%d байт]\n", str, (int)strlen( str ) ); 
}
//----------------------------------------------------------
void test03( void ) {
   char *loc = setlocale( LC_ALL, NULL );   // показать текущую локаль
   printf( "локаль программы по умолчанию: %s\n", loc );
}
//----------------------------------------------------------
void test04( void ) {
   char *loc = setlocale( LC_CTYPE, "ru_RU.utf8" );  
   if( NULL == loc ) perror( "locale error" );
   else fprintf( stdout, "локализация: %s\n", loc );
}
//-----------------------------------------------------
void test05( void ) {
   char *loc = setlocale( LC_ALL, "" ); // по умолчанию ("") - из $LANG
   fprintf( stdout, "локализация: %s\n", loc );
}
//-----------------------------------------------------
static char* revb( char *s ) {
   int i, j;
   for( i = 0, j = strlen( s ) - 1; i <= j; i++, j-- ) {
      char c = s[ i ];
      s[ i ] = s[ j ];
      s[ j ] = c;
   }
   return s;
}

void test06( void ) {
   char se[] = "abcdefghijklmnopqrstu",
        sr[] = "абвгдеёжзийклмнопрсту";
   printf( "%s => %s\n", se, revb( strdup( se ) ) );
   printf( "%s => %s\n", sr, revb( strdup( sr ) ) );
}
//-----------------------------------------------------
#define LENGTH 160
char    buf  [ LENGTH ] = "тестовая русскоязычная  строка  в UTF-8 с прямым порядком слов ";
wchar_t wbuf [ LENGTH ];
//-----------------------------------------------------
inline void c2w( char *c, wchar_t *w ) {
   int n = -1;
   setlocale( LC_ALL, "" );  // только после этого работают преобразования!
   while( n != 0 )  
      c += ( n = mbtowc( w++, c, MB_CUR_MAX ) ); 
}

void test07( void ) {
   printf( "преобразование UTF-8 символов в широкие (wchar_t):\n" );
   printf( "строка UTF-8 до преобразования: '%s'\n"
           "длина UTF-8 строки = %d байт\n",
           buf, (int)strlen( buf ) );
   c2w( buf, wbuf );
   printf( "локаль программы установлена: %s\n", 
           setlocale( LC_ALL, NULL ) );
   printf( "преобразованная строка: '%ls'\n"
           "длина преобразованной строки = %d символов (%ld байт)\n",
           wbuf, (int)wcslen( wbuf ),
           wcslen( wbuf ) * sizeof( wchar_t ) );
}
//-----------------------------------------------------
void test08( void ) {
   int n;
   c2w( buf, wbuf );
   printf( "обратное преобразование в UTF-8: %d байт\n", n = wcstombs( NULL, wbuf, 0 ) );
   wcstombs( buf, wbuf, n + 1 );  // с завершающим нулём
   printf( "преобразованная UTF-8 строка: '%s'\n", buf );
}
//-----------------------------------------------------
void revers( wchar_t *w ) {
   wchar_t *sec, wb[ 40 ];
   if( NULL == ( sec = wcschr( w, L' ' ) ) ) return;
   wcsncpy( wb, w, sec - w )[ sec - w ] = L'\0';
   while( L' ' == *sec ) sec++;
   revers( sec );
   wcscat( wcscat( wmemmove( w, sec, wcslen( sec ) + 1 ), L" " ), wb );
}

void test09( void ) {
   c2w( buf, wbuf );
   while( L' ' == wbuf[ wcslen( wbuf ) - 1 ] ) 
      wbuf[ wcslen( wbuf ) - 1 ] = L'\0';
   printf( "устранение завершающих пробелов: '%ls'\n", wbuf );
   revers( wbuf );
   printf( "реверсирование слов: '%ls'\n", wbuf );
   revers( wbuf );
   printf( "реверсирование слов: '%ls'\n", wbuf );
}
//-----------------------------------------------------
void test10( void ) {
   char cs[] = "c-строка";
   wchar_t ws[] = L"w-строка";
   printf( "%s\n", cs );
   printf( "%ls\n", ws );
   printf( "%s\n", cs );
   printf( "%ls\n", ws );
}
//-----------------------------------------------------
void test11( void ) {
   setlocale( LC_ALL, "" );
   int res;
   char cs[] = "c-строка\n";
   wchar_t ws[] = L"w-строка\n";
   setlocale( LC_ALL, "" );
   res = fputws( ws, stdout );
   printf( " %d: %m\n", res );
   res = fputs( cs, stdout );
   printf( " %d: %m\n", res );
   res = fputws( ws, stdout );
   printf( " %d: %m\n", res );
   res = fputs( cs, stdout );
   printf( " %d: %m\n", res );
}
//-----------------------------------------------------
void test12( void ) {
   int res;
   char cs[] = "c-строка\n";
   wchar_t ws[] = L"w-строка\n";
   setlocale( LC_ALL, "" );
   res = fputs( cs, stdout );
   printf( " %d: %m\n", res );
   res = fputws( ws, stdout );
   printf( " %d: %m\n", res );
   res = fputs( cs, stdout );
   printf( " %d: %m\n", res );
   res = fputws( ws, stdout );
   printf( " %d: %m\n", res );
}
//-----------------------------------------------------
void test13( void ) {
   int res;
   char cs[] = "c-строка\n";
   wchar_t ws[] = L"w-строка\n";
   setlocale( LC_ALL, "" );
   res = fputs( cs, stdout );
   printf( " %d: %m\n", res );
   stdout = freopen( NULL, "w", stdout );
   res = fputws( ws, stdout );
   stdout = freopen( NULL, "w", stdout );
   printf( " %d: %m\n", res );
   res = fputs( cs, stdout );
   printf( " %d: %m\n", res );
   stdout = freopen( NULL, "w", stdout );
   res = fputws( ws, stdout );
   stdout = freopen( NULL, "w", stdout );
   printf( " %d: %m\n", res );
}
//-----------------------------------------------------

void ( *tests[] )( void ) = {     // последовательность тестов
        test00, test01, test02,
        test03, test04, test05,
        test06, test07, test08,
        test09, test10, test11,
        test12, test13,
};

static void do_test( int i ) {
   printf( "%02d ---------------------------------------\n", i );
   stdout = freopen( NULL, "w", stdout );
   tests[ i ]();
   stdout = freopen( NULL, "w", stdout );
}

int main( int argc, char **argv, char **envp ) {
   int i, j;
   for( i = 0; i < sizeof( tests ) / sizeof( tests[ 0 ] ); i++ ) 
      if( 1 == argc ) 
         do_test( i );
      else
         for( j = 0; j < argc - 1; j++ ) 
            if( atoi( argv[ j + 1 ] ) == i )
               do_test( i );
   printf( "------------------------------------------\n" );
   return 0;
}
